package com.example.heresdkandroidref.activity;

import android.content.Intent;
import android.os.Build;
import android.os.Bundle;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.example.heresdkandroidref.R;
import com.example.heresdkandroidref.adapters.SwitchAdapter;
import com.example.heresdkandroidref.utils.Utils;
import com.here.sdk.core.CountryCode;
import com.here.sdk.routing.RoadFeatures;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.List;
import java.util.Map;

public class AvoidCountriesActivity extends AppCompatActivity {

    Toolbar toolbarTB;
    RecyclerView countriesRV;
    Map<String, CountryCode> countryCodeMap = Utils.getCountryCodeMap();
    ArrayList<String> selectedCountries = new ArrayList<>();
    private SwitchAdapter switchAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_avoid_countries);
        selectedCountries = getIntent().getStringArrayListExtra("countries");
        initViews();
    }

    private void initViews() {
        toolbarTB = findViewById(R.id.toolbarTB);
        countriesRV = findViewById(R.id.countriesRV);

        toolbarTB.setTitle("Avoid countries");
        setSupportActionBar(toolbarTB);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        //initialize road features
        countriesRV.setHasFixedSize(true);
        countriesRV.setLayoutManager(new LinearLayoutManager(this));
        List<String> countryList = Arrays.asList(countryCodeMap.keySet().toArray(new String[0]));
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
            countryList.sort(String::compareTo);
        }
        switchAdapter = new SwitchAdapter(this, countryList, selectedCountries);
        countriesRV.setAdapter(switchAdapter);
    }

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        Intent intent = new Intent();
        intent.putStringArrayListExtra("countries", switchAdapter.getSelectedItems());
        setResult(RESULT_OK,intent);
        finish();
    }
}