package com.example.heresdkandroidref.activity;

import android.content.Intent;
import android.os.Bundle;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.example.heresdkandroidref.R;
import com.example.heresdkandroidref.adapters.SwitchAdapter;
import com.example.heresdkandroidref.utils.Utils;
import com.here.sdk.routing.RoadFeatures;
import com.here.sdk.transport.HazardousMaterial;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Map;

public class HazardousGoodsActivity extends AppCompatActivity {

    Toolbar toolbarTB;
    RecyclerView hazardousGoodsRV;
    Map<String, HazardousMaterial> hazardousGoodsMap = Utils.getHazardousGoodsMap();
    ArrayList<String> selectedHazardousGoods = new ArrayList<>();
    private SwitchAdapter switchAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_hazardous_goods);
        selectedHazardousGoods = getIntent().getStringArrayListExtra("hazardousGoods");
        initViews();
    }

    private void initViews() {
        toolbarTB = findViewById(R.id.toolbarTB);
        hazardousGoodsRV = findViewById(R.id.hazardousGoodsRV);

        toolbarTB.setTitle("Hazardous goods");
        setSupportActionBar(toolbarTB);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        //initialize road features
        hazardousGoodsRV.setHasFixedSize(true);
        hazardousGoodsRV.setLayoutManager(new LinearLayoutManager(this));
        switchAdapter = new SwitchAdapter(this, Arrays.asList(hazardousGoodsMap.keySet().toArray(new String[0])), selectedHazardousGoods);
        hazardousGoodsRV.setAdapter(switchAdapter);
    }

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        Intent intent = new Intent();
        intent.putStringArrayListExtra("hazardousGoods", switchAdapter.getSelectedItems());
        setResult(RESULT_OK,intent);
        finish();
    }
}