package com.example.heresdkandroidref.activity;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import androidx.viewpager2.widget.ViewPager2;

import android.content.Intent;
import android.os.Bundle;

import com.example.heresdkandroidref.R;
import com.example.heresdkandroidref.adapters.SwitchAdapter;
import com.example.heresdkandroidref.utils.Utils;
import com.google.android.material.tabs.TabLayout;
import com.here.sdk.routing.RoadFeatures;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

public class RoadFeaturesActivity extends AppCompatActivity {

    Toolbar toolbarTB;
    RecyclerView roadFeaturesRV;
    Map<String, RoadFeatures> roadFeaturesMap = Utils.getRoadFeaturesMap();
    ArrayList<String> selectedRoadFeatures = new ArrayList<>();
    private SwitchAdapter switchAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_road_features);
        selectedRoadFeatures = getIntent().getStringArrayListExtra("roadFeatures");
        initViews();
    }

    private void initViews() {
        toolbarTB = findViewById(R.id.toolbarTB);
        roadFeaturesRV = findViewById(R.id.roadFeaturesRV);

        toolbarTB.setTitle("Avoid road features");
        setSupportActionBar(toolbarTB);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        //initialize road features
        roadFeaturesRV.setHasFixedSize(true);
        roadFeaturesRV.setLayoutManager(new LinearLayoutManager(this));
        switchAdapter = new SwitchAdapter(this, Arrays.asList(roadFeaturesMap.keySet().toArray(new String[0])), selectedRoadFeatures);
        roadFeaturesRV.setAdapter(switchAdapter);
    }

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        Intent intent = new Intent();
        intent.putStringArrayListExtra("roadFeatures", switchAdapter.getSelectedItems());
        setResult(RESULT_OK,intent);
        finish();
    }
}