package com.example.heresdkandroidref.adapters;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.recyclerview.widget.RecyclerView;

import com.example.heresdkandroidref.R;
import com.example.heresdkandroidref.features.OfflineMapsExample;
import com.example.heresdkandroidref.features.OfflineMapsExampleOld;
import com.here.sdk.maploader.Region;

import java.util.ArrayList;
import java.util.List;


public class InstalledRegionsAdapter extends RecyclerView.Adapter<InstalledRegionsAdapter.ViewHolder> {

    public Context context;
    List<Region> regionArrayList;
    public InstalledRegionItemClickListener onItemClickListener;
    public OfflineMapsExample offlineMapsExample;

    public InstalledRegionsAdapter(Context context, List<Region> regionArrayList, InstalledRegionItemClickListener clickListener, OfflineMapsExample offlineMapsExample) {
        this.context = context;
        onItemClickListener = clickListener;
        this.regionArrayList = regionArrayList;
        this.offlineMapsExample = offlineMapsExample;
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup viewGroup, int i) {
        View itemView = LayoutInflater.from(viewGroup.getContext())
                .inflate(R.layout.row_region_item, viewGroup, false);
        return new ViewHolder(itemView);
    }

    @Override
    public void onBindViewHolder(ViewHolder viewHolder, int position) {

        initData(viewHolder, position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public int getItemCount() {
        return regionArrayList.size();
    }

    private void initData(final ViewHolder viewHolder, final int position) {
        final Region region = regionArrayList.get(position);
        viewHolder.itemRegionName.setText(region.name);
        viewHolder.itemRegionImg.setImageDrawable(context.getResources().getDrawable(android.R.drawable.ic_menu_info_details));
        long sizeOnDiskInMB = region.sizeOnDiskInBytes / (1024 * 1024);
        viewHolder.itemRegionItems.setText(String.format("%d MB", sizeOnDiskInMB));
        viewHolder.itemRegionImg.setOnClickListener(view -> {

        });
        viewHolder.itemMain.setOnClickListener(view -> {

        });


    }

    public void customUpdateList(List<Region> regionArrayList) {
        this.regionArrayList = regionArrayList;
        notifyDataSetChanged();
    }


    static class ViewHolder extends RecyclerView.ViewHolder {
        public TextView itemRegionName, itemRegionItems;
        public ImageView itemRegionImg;
        public LinearLayout itemMain;

        private ViewHolder(View convertView) {
            super(convertView);
            itemRegionItems = convertView.findViewById(R.id.region_items_txt);
            itemRegionName = convertView.findViewById(R.id.region_name_txt);
            itemRegionImg = convertView.findViewById(R.id.region_img);
            itemMain = convertView.findViewById(R.id.main_cv);
            convertView.setOnClickListener(view -> {

            });

        }
    }

    public interface InstalledRegionItemClickListener{
        void onClickMoreOnInstalledRegion(int position);
    }

}
