package com.example.heresdkandroidref.adapters;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.example.heresdkandroidref.R;
import com.example.heresdkandroidref.interfaces.GPXTracksClickListener;
import com.example.heresdkandroidref.interfaces.ItemType;
import com.example.heresdkandroidref.interfaces.ItemsClickListener;

import java.io.File;
import java.util.ArrayList;


public class TracksAdapter extends RecyclerView.Adapter<TracksAdapter.ViewHolder> {

    public Context context;
    ArrayList<File> itemsArrayList;
    public GPXTracksClickListener listener;


    public TracksAdapter(Context context, ArrayList<File> itemsArrayList, GPXTracksClickListener clickListener) {
        this.context = context;
        this.listener = clickListener;
        this.itemsArrayList = itemsArrayList;
    }

    @NonNull
    @Override
    public ViewHolder onCreateViewHolder(ViewGroup viewGroup, int i) {
        View itemView = LayoutInflater.from(viewGroup.getContext())
                .inflate(R.layout.row_tracks_item, viewGroup, false);
        return new ViewHolder(itemView);
    }

    @Override
    public void onBindViewHolder(ViewHolder viewHolder, int position) {
        initData(viewHolder, position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public int getItemCount() {
        return itemsArrayList.size();
    }

    private void initData(final ViewHolder viewHolder, final int position) {
        viewHolder.tracks_txt.setText(itemsArrayList.get(position).getName());
        viewHolder.itemView.setOnClickListener(view -> listener.onItemClick(view, position));
        viewHolder.deleteIV.setOnClickListener(view -> listener.onItemDeleteClick(view, position));
    }

    static class ViewHolder extends RecyclerView.ViewHolder {
        public TextView tracks_txt;
        public ImageView deleteIV;

        private ViewHolder(View convertView) {
            super(convertView);
            tracks_txt = convertView.findViewById(R.id.tracks_txt);
            deleteIV = convertView.findViewById(R.id.deleteIV);
        }
    }


}
