package com.example.heresdkandroidref.utils;

import android.app.Dialog;
import android.content.Context;

import com.example.heresdkandroidref.R;


public class LoadingDialog extends Dialog {

    public LoadingDialog(Context context) {
        super(context, R.style.FullScreenDialogStyle);
        requestWindowFeature(1);
        setContentView(R.layout.dialog_loading);
        setCancelable(false);
        setCanceledOnTouchOutside(false);
    }

    public void show() {
        if (!isShowing()) {
            super.show();
        }
    }

    public void dismiss() {
        if (isShowing()) {
            super.dismiss();
        }
    }

    public void cancel() {
        if (isShowing()) {
            super.cancel();
        }
    }

    public static void showDialog(LoadingDialog dialog) {
        if (dialog != null && !dialog.isShowing()) {
            dialog.show();
        }
    }

    public static void dismissDialog(LoadingDialog dialog) {
        if (dialog != null && dialog.isShowing()) {
            dialog.dismiss();
        }
    }

    public static void cancelDialog(LoadingDialog dialog) {
        if (dialog != null) {
            dialog.cancel();
        }
    }

}
